/*******************************
 * soubor io-brr.c
 * podle pozadavku cte n-tou hodnotu
 * typu double z existujiciho
 * binarniho souboru odmoc.dta
 *******************************/

#include <stdio.h>

int main(void)
{
 const int od = 0, po = 99;
 FILE *vstup;
 char *jmeno = "odmoc.dta",
      *vyzva = "zadej int od %d po %d: ";
 double f;
 int i;

 if ((vstup = fopen(jmeno, "rb")) == NULL)
   {
    printf("Chyba!\nSoubor %s nejde otevrit.\n",
            jmeno);
    return 1;
   }

  i = 0;
  printf(vyzva, od, po);
  scanf("%d", &i);

  while((i >= od) && (i <= po))
  /* nekonecny cyklus, konec zevnitr! */
   {
    if (fseek(vstup, i * sizeof(double), SEEK_SET) != 0)
      {
       printf("Chyba pri presunu na index %2d\n", i);
       return 1;
      }
    if (fread(&f, sizeof(double), 1, vstup) != 1)
    /* cteme ze vstupu jeden double a kontrolujeme to */
      {
       printf("Chyba pri cteni %2d. hodnoty\n", i);
       return 1; /* nepovedlo se - konec */
      }
    printf("%3d%8.5f\n", i++, f);
    printf(vyzva, od, po);
    scanf("%d", &i);
   }  /* while((i >= od) && (i <= po)) */
 puts("konec programu\n");
 fclose(vstup);
 return 0;
} /* int main(void) */
